import networkx as nx

"""g = nx.DiGraph()
g.add_nodes_from([1,2,3,4])
g.add_edges_from([(1,2),(1,4),(2,4),(2,3)])
g = g.to_undirected()
nx.draw(g, with_labels=True, font_weight='bold')
plt.show()"""

#Initialize
g = nx.Graph(nx.read_edgelist("adjList.txt","#")).to_undirected()
degrees = dict(nx.degree(g))
numOfNodes = len(degrees)
swapDegrees = dict()
for v in set(degrees.values()):
    for k in degrees.keys():
        if degrees[k] == v:
            if v not in swapDegrees.keys():
                swapDegrees[v] = []
            swapDegrees[v].append(k)
print("Degrees: ", degrees)
print("Swap Degrees: ", swapDegrees)

#Compute degree of graph
degreeOfGraph = 0
for v in degrees.values():
    degreeOfGraph += v
degreeOfGraph /= numOfNodes
print("Degree of Graph: ",degreeOfGraph)

#Compute degree distribution
Pk = dict()
for k in swapDegrees.keys():
    Pk[k] = len(swapDegrees[k])/numOfNodes
print("P(k): ",Pk)

#Compute average graph degree
averageGraphDegree = 0
for k in swapDegrees.keys():
    averageGraphDegree += k*Pk[k]
print("<k>: ",averageGraphDegree)

#Compute joint degree distribution
k1 = int(input("Enter k1:"))
k2 = int(input("Enter k2:"))
k1List = swapDegrees[k1]
k2List = swapDegrees[k2]
mk1k2 = 0
for i in k1List:
    for j in k2List:
        if j in g.edge[i]:
            mk1k2 += 1
pk1k2 = mk1k2/len(g.edge)
print("P(k1,k2): ",pk1k2)

#Compute distance of nodes:
print("Distance of nodes: ",nx.eccentricity(g))

#Compute diameter of graph
print("Diameter of graph: ",nx.diameter(g))

#Compute clustering coefficient
print("Clustering coefficient: ",nx.average_clustering(g))

#Compute closeness of nodes
print("Closeness of nodes: ",nx.closeness_centrality(g))

#Compute coreness of nodes
print("Coreness of nodes: ",nx.core_number(g))

#Compute betweenness of nodes
print("Betweenness of nodes: ",nx.betweenness_centrality(g))